<script lang="ts" setup>
import { computed, onMounted, reactive, ref } from 'vue'
import { useBillCostStore } from '@/stores/billcost'
// import billcostService from '@/services/billcost'
import { Bar } from 'vue-chartjs'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale,
  LineElement,
  PointElement
} from 'chart.js'
import type auth from '@/services/auth'
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch'
const authStore = useAuthStore()
const branchStore = useBranchStore()
const billcostStore = useBillCostStore()
const labelss = ref<string[]>([])
const dataValues = ref<number[]>([])
const isdisable = ref(true)
const isMonth = ref(false)
const isDays = ref(false)
const isYear = ref(false)
const OffB1 = ref(false)
const OffB2 = ref(false)
const selectedYear = ref(new Date().getFullYear())
const selectedYear2 = ref(new Date().getMonth())
const datePicker = ref()
const selectedButton = ref()
const MM = ref()
onMounted(async () => {
  // await billcostStore.getBillCostsreportTotalCostByType() // หา type ทั้งหมด 2 สาขา แล้วรวม
  // await billcostStore.getBillCostsreportTotalCostByTypeAndBranch('2', '1') //หาtype ใน branch แล้ว รวม
  //  await billcostStore.getBillCostsreportTotalCostByUserAndType() // หา user ทั้งหมด 2 สาขา แล้วรวม
  // await billcostStore.GetBillTotalByBranchAndTypePerYear(2, 2024)
  dataSet()
  // setMonthly()
})

function onOffB1() {
  OffB1.value = true
  OffB2.value = false
}

function YearB1() {
  setYear(1)
}

function MonthB1() {
  setMonth(1)
}

function MonthB2() {
  setMonth(2)
}

function onOffB2() {
  OffB2.value = true
  OffB1.value = false
}

function YearB2() {
  setYear(2)
}

function dataSet() {
  labelss.value = billcostStore.data.map((item: any) => {
    return item.typebillcost_month
  })
  console.log(labelss.value)

  dataValues.value = billcostStore.data.map((item: any) => {
    return item.total_cost
  })
  console.log(dataValues.value)
}

ChartJS.register(
  CategoryScale,
  LinearScale,
  BarElement,
  LineElement,
  PointElement,
  Title,
  Tooltip,
  Legend
)
const chartData = computed(() => ({
  labels: labelss.value,
  datasets: [
    {
      label: 'Data One',
      backgroundColor: '#f87979',
      data: dataValues.value
    }
  ]
}))

const chartOptions = ref({
  responsive: true,
  maintainAspectRatio: false
})

async function setMonthly() {
  labelss.value = []
  dataValues.value = []
  console.log('setMonthly', selectedButton.value)
  await billcostStore.BillTotalByBranch(selectedButton.value)

  labelss.value = billcostStore.data.map((item: any) => {
    return item.typebillcost_month
  })
  console.log('LABELs' + labelss.value)

  dataValues.value = billcostStore.data.map((item: any) => {
    return item.total_cost
  })
  console.log(dataValues.value)
  settotal()
}

function setMonth(n: number) {
  t.value = 0
  selectedButton.value = n
  console.log('n', selectedButton.value)
  labelss.value = []
  dataValues.value = []
  isdisable.value = false
  isYear.value = false
  isDays.value = false
  setMonthly()
  // isMonth.value = true
  // setMonthly()
}
const t = ref(0)
async function setYearly() {
  labelss.value = []
  dataValues.value = []
  datePicker.value = selectedYear.value
  console.log('Year ' + datePicker.value)
  await billcostStore.GetBillTotalByBranchAndTypePerYear(selectedButton.value, datePicker.value)

  labelss.value = billcostStore.data.map((item: any) => {
    return item.typebillcost_month
  })
  console.log('Labless ' + labelss.value)

  dataValues.value = billcostStore.data.map((item: any) => {
    return item.total_cost
  })
  console.log('dataValues ' + dataValues.value)
  settotal()
}

function setYear(n: number) {
  t.value = 0
  selectedButton.value = n
  console.log('n', selectedButton.value)
  labelss.value = []
  dataValues.value = []
  isdisable.value = false
  isdisable.value = false
  isDays.value = false
  isMonth.value = false
  isYear.value = true
}

function settotal() {
  for (let i = 0; i < dataValues.value.length; i++) {
    //  t.value =+parseInt(JSON.stringify(dataValues.value[i]))
    t.value = t.value + Number(dataValues.value[i])

    //  console.log("T value "+t.value);
  }
  console.log(t.value)
}
function resetAll() {
  labelss.value = []
  dataValues.value = []
  OffB1.value = false
  OffB2.value = false
  isMonth.value = false
  isYear.value = false
  isDays.value = false
  selectedYear.value = new Date().getFullYear()
  selectedYear2.value = new Date().getMonth()
  datePicker.value = null
  selectedButton.value = null
  MM.value = null
  t.value = 0
}
</script>
<template>
  <!-- <Bar id="my-chart-id" :options="chartOptions" :data="chartData" /> -->
  <v-dialog
    v-model="billcostStore.dialogReport"
    fullscreen
    :scrim="false"
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar dark color="#604C46">
        <v-btn icon dark @click="billcostStore.dialogReport = !billcostStore.dialogReport">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Bill Cost Report</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>

      <v-container>
        <v-row>
          <v-sheet width="1300" height="110">
            <div style="text-align: center; font-size: 40px">Report</div>
          </v-sheet>

          <v-text-field
            type="month"
            v-model="datePicker"
            :disabled="isdisable"
            v-if="isMonth == true"
            @input="setMonthly()"
            label="Select Month"
          ></v-text-field>

          <v-text-field
            type="number"
            v-model="selectedYear"
            :disabled="isdisable"
            v-if="isYear == true"
            label="Select Year"
            append-inner-icon="mdi-send"
            @click:append-inner="setYearly()"
          ></v-text-field>

          <v-spacer></v-spacer>
          <v-btn
            style="margin-right: 10px"
            :color="OffB1 ? 'blue' : 'grey'"
            v-if="OffB1"
            @click="YearB1()"
            >Month
          </v-btn>
          <v-btn
            style="margin-right: 10px"
            :color="OffB1 ? 'blue' : 'grey'"
            v-if="OffB1"
            @click="MonthB2()"
            >Year
          </v-btn>
          <!-- <v-btn
            style="margin-right: 10px"
            :color="OffB1 ? 'blue' : 'grey'"
            v-if="OffB1"
            @click="MonthB1()"
            >Month
          </v-btn> -->
          <v-btn
            style="margin-right: 10px"
            :color="OffB2 ? 'blue' : 'grey'"
            v-if="OffB2"
            @click="YearB2()"
            >Month
          </v-btn>
          <v-btn
            style="margin-right: 10px"
            :color="OffB2 ? 'blue' : 'grey'"
            v-if="OffB2"
            @click="MonthB2()"
            >Year
          </v-btn>
          <!-- <v-btn
            style="margin-right: 10px"
            :color="OffB2 ? 'blue' : 'grey'"
            v-if="OffB2"
            @click="MonthB2()"
            >Month
          </v-btn> -->
          <v-btn
            style="margin-right: 10px"
            :color="OffB1 ? 'grey' : OffB2 ? 'grey' : 'blue'"
            @click="onOffB1()"
            >1</v-btn
          >
          <v-btn
            :color="OffB1 ? 'grey' : OffB2 ? 'grey' : 'blue'"
            @click="onOffB2()"
            style="margin-right: 10px"
            >2</v-btn
          >

          <v-btn @click="resetAll" style="margin-right: 10px">reset</v-btn>
          <!-- <v-btn @click="openDialog()">test</v-btn> -->
        </v-row>

        <!-- {{ datePicker }} -->
        <v-row no-gutters>
          <v-sheet width="1250" height="550" class="overflow-auto">
            <Bar :data="chartData" :options="chartOptions" />
            <!-- {{ billcostStore.labels }}
            {{ billcostStore.dataset }} -->
          </v-sheet>
          <v-col v-if="isMonth == true">Total of Month: {{ t }}</v-col>
          <v-col v-if="isYear == true">Total of Year: {{ t }}</v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>

  <!-- <v-dialog v-model="B1">
    <v-card>
      <v-toolbar>
        <v-toolbar-title>Bill Cost Report1</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>
    </v-card>
  </v-dialog> -->
</template>
